//
// JobDetailsAPI.swift
//
// Generated by swagger-codegen
// https://github.com/swagger-api/swagger-codegen
//

import Foundation
import Alamofire


open class JobDetailsAPI {
    /**
     /jobs/{id}

     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getJob(_id: String, completion: @escaping ((_ data: Job?,_ error: Error?) -> Void)) {
        getJobWithRequestBuilder(_id: _id).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs/{id}
     - GET /jobs/{id}

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "options" : {
    "faxHeader" : true,
    "saveDocuments" : false,
    "faxHeaderFrom" : "Max Mustermann",
    "defaultInternationalDialingCode" : "0049",
    "costCenter" : "Kösten",
    "timeToSend" : "2022-01-01T10:00:00+02:00",
    "title" : "Fax Job ABC 123",
    "timeToSendUntil" : "2030-01-01T10:00:00+02:00",
    "clip" : "0525187929310",
    "stationID" : "test12345"
  },
  "errorCode" : 503,
  "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
  "account" : "ApiAccount123",
  "status" : "scheduling",
  "info" : {
    "templateIsAvailable" : true,
    "previewIsAvailable" : true
  },
  "statistics" : {
    "surcharge" : 1,
    "recipientCountSuccessful" : 8,
    "recipientCountError" : 2,
    "pages" : 1,
    "recipientCount" : 10
  }
}}]
     - parameter _id: (path) Identification number (UUID) of the job 

     - returns: RequestBuilder<Job> 
     */
    open class func getJobWithRequestBuilder(_id: String) -> RequestBuilder<Job> {
        var path = "/jobs/{id}"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Job>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     /jobs/{id}/notifications

     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getJobNotifications(_id: String, completion: @escaping ((_ data: Notifications?,_ error: Error?) -> Void)) {
        getJobNotificationsWithRequestBuilder(_id: _id).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs/{id}/notifications
     - GET /jobs/{id}/notifications

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "total" : 100,
  "offset" : 0,
  "data" : [ {
    "triggeredError" : true,
    "destination" : "max.mustermann@mailserver.com",
    "type" : "type",
    "triggeredSuccessful" : true
  }, {
    "triggeredError" : true,
    "destination" : "max.mustermann@mailserver.com",
    "type" : "type",
    "triggeredSuccessful" : true
  } ],
  "count" : 50
}}]
     - parameter _id: (path) Identification number (UUID) of the job 

     - returns: RequestBuilder<Notifications> 
     */
    open class func getJobNotificationsWithRequestBuilder(_id: String) -> RequestBuilder<Notifications> {
        var path = "/jobs/{id}/notifications"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Notifications>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     /jobs/{id}/preview

     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getJobPreviews(_id: String, completion: @escaping ((_ data: Preview?,_ error: Error?) -> Void)) {
        getJobPreviewsWithRequestBuilder(_id: _id).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs/{id}/preview
     - GET /jobs/{id}/preview

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "contentType" : "application/pdf",
  "content" : "JVBERi0xLj***SVFT0YNCg=="
}}]
     - parameter _id: (path) Identification number (UUID) of the job 

     - returns: RequestBuilder<Preview> 
     */
    open class func getJobPreviewsWithRequestBuilder(_id: String) -> RequestBuilder<Preview> {
        var path = "/jobs/{id}/preview"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Preview>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     * enum for parameter sortField
     */
    public enum SortField_getJobRecipients: String { 
        case faxnumber = "faxNumber"
        case faxnumbernorm = "faxNumberNorm"
        case internationaldialingcode = "internationalDialingCode"
        case recipientreference = "recipientReference"
        case farezone = "fareZone"
        case sendertime = "senderTime"
    }

    /**
     * enum for parameter sortOrder
     */
    public enum SortOrder_getJobRecipients: String { 
        case asc = "asc"
        case desc = "desc"
    }

    /**
     /jobs/{id}/recipients

     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter objectLimit: (query) Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     - parameter objectOffset: (query) Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     - parameter filterFaxNumber: (query) Query parameter to fetch recipients after his fax number (optional)
     - parameter filterFaxNumberNorm: (query) Query parameter to fetch recipients after his normed fax number (optional)
     - parameter filterRecipientReference: (query) Query parameter to fetch recipients after his recipient reference (optional)
     - parameter filterInternationalDialingCode: (query) Query parameter to fetch recipients after his international dialing code (optional)
     - parameter filterResultCode: (query) Query parameter to fetch recipients after his result code (optional)
     - parameter filterResultText: (query) Query parameter to fetch recipients after his result text (optional)
     - parameter sortField: (query) Available sort options for the result data array. (optional)
     - parameter sortOrder: (query) Describes the order for used sort fields (optional, default to asc)
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getJobRecipients(_id: String, objectLimit: Int? = nil, objectOffset: Int? = nil, filterFaxNumber: String? = nil, filterFaxNumberNorm: String? = nil, filterRecipientReference: String? = nil, filterInternationalDialingCode: String? = nil, filterResultCode: String? = nil, filterResultText: String? = nil, sortField: SortField_getJobRecipients? = nil, sortOrder: SortOrder_getJobRecipients? = nil, completion: @escaping ((_ data: JobRecipients?,_ error: Error?) -> Void)) {
        getJobRecipientsWithRequestBuilder(_id: _id, objectLimit: objectLimit, objectOffset: objectOffset, filterFaxNumber: filterFaxNumber, filterFaxNumberNorm: filterFaxNumberNorm, filterRecipientReference: filterRecipientReference, filterInternationalDialingCode: filterInternationalDialingCode, filterResultCode: filterResultCode, filterResultText: filterResultText, sortField: sortField, sortOrder: sortOrder).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs/{id}/recipients
     - GET /jobs/{id}/recipients

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "total" : 100,
  "offset" : 0,
  "data" : [ {
    "internationalDialingCode" : "0049",
    "resultText" : "The fax was sent successfully",
    "faxNumberNorm" : "0525187929399",
    "senderTime" : "2022-01-01T10:00:00+02:00",
    "name" : "Max Mustermann",
    "resultCode" : 0,
    "faxNumber" : "0525187929399",
    "recipientReference" : "User 1234 ABC",
    "fareZone" : 1
  }, {
    "internationalDialingCode" : "0049",
    "resultText" : "The fax was sent successfully",
    "faxNumberNorm" : "0525187929399",
    "senderTime" : "2022-01-01T10:00:00+02:00",
    "name" : "Max Mustermann",
    "resultCode" : 0,
    "faxNumber" : "0525187929399",
    "recipientReference" : "User 1234 ABC",
    "fareZone" : 1
  } ],
  "count" : 50
}}]
     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter objectLimit: (query) Query parameter to change de default limitation of objects in the result data array (optional, default to 100)
     - parameter objectOffset: (query) Query parameter to change de default offset of objects in the result data array (optional, default to 0)
     - parameter filterFaxNumber: (query) Query parameter to fetch recipients after his fax number (optional)
     - parameter filterFaxNumberNorm: (query) Query parameter to fetch recipients after his normed fax number (optional)
     - parameter filterRecipientReference: (query) Query parameter to fetch recipients after his recipient reference (optional)
     - parameter filterInternationalDialingCode: (query) Query parameter to fetch recipients after his international dialing code (optional)
     - parameter filterResultCode: (query) Query parameter to fetch recipients after his result code (optional)
     - parameter filterResultText: (query) Query parameter to fetch recipients after his result text (optional)
     - parameter sortField: (query) Available sort options for the result data array. (optional)
     - parameter sortOrder: (query) Describes the order for used sort fields (optional, default to asc)

     - returns: RequestBuilder<JobRecipients> 
     */
    open class func getJobRecipientsWithRequestBuilder(_id: String, objectLimit: Int? = nil, objectOffset: Int? = nil, filterFaxNumber: String? = nil, filterFaxNumberNorm: String? = nil, filterRecipientReference: String? = nil, filterInternationalDialingCode: String? = nil, filterResultCode: String? = nil, filterResultText: String? = nil, sortField: SortField_getJobRecipients? = nil, sortOrder: SortOrder_getJobRecipients? = nil) -> RequestBuilder<JobRecipients> {
        var path = "/jobs/{id}/recipients"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        var url = URLComponents(string: URLString)
        url?.queryItems = APIHelper.mapValuesToQueryItems([
                        "objectLimit": objectLimit?.encodeToJSON(), 
                        "objectOffset": objectOffset?.encodeToJSON(), 
                        "filterFaxNumber": filterFaxNumber, 
                        "filterFaxNumberNorm": filterFaxNumberNorm, 
                        "filterRecipientReference": filterRecipientReference, 
                        "filterInternationalDialingCode": filterInternationalDialingCode, 
                        "filterResultCode": filterResultCode, 
                        "filterResultText": filterResultText, 
                        "sortField": sortField?.rawValue, 
                        "sortOrder": sortOrder?.rawValue
        ])


        let requestBuilder: RequestBuilder<JobRecipients>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     /jobs/{id}/templates

     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func getJobTemplates(_id: String, completion: @escaping ((_ data: Templates?,_ error: Error?) -> Void)) {
        getJobTemplatesWithRequestBuilder(_id: _id).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs/{id}/templates
     - GET /jobs/{id}/templates

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "total" : 100,
  "offset" : 0,
  "data" : [ {
    "contentType" : "application/pdf",
    "content" : "JVBERi0xLj***SVFT0YNCg=="
  }, {
    "contentType" : "application/pdf",
    "content" : "JVBERi0xLj***SVFT0YNCg=="
  } ],
  "count" : 50
}}]
     - parameter _id: (path) Identification number (UUID) of the job 

     - returns: RequestBuilder<Templates> 
     */
    open class func getJobTemplatesWithRequestBuilder(_id: String) -> RequestBuilder<Templates> {
        var path = "/jobs/{id}/templates"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters: [String:Any]? = nil
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Templates>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "GET", URLString: (url?.string ?? URLString), parameters: parameters, isBody: false)
    }
    /**
     /jobs/{id}

     - parameter body: (body) Describes the required request body to perform an action on the fax job 
     - parameter _id: (path) Identification number (UUID) of the job 
     - parameter completion: completion handler to receive the data and the error objects
     */
    open class func putJob(body: JobsIdBody, _id: String, completion: @escaping ((_ data: Job?,_ error: Error?) -> Void)) {
        putJobWithRequestBuilder(body: body, _id: _id).execute { (response, error) -> Void in
            completion(response?.body, error)
        }
    }


    /**
     /jobs/{id}
     - PUT /jobs/{id}

     - API Key:
       - type: apiKey X-Auth-Token 
       - name: ApiAuthKey
     - examples: [{contentType=application/json, example={
  "options" : {
    "faxHeader" : true,
    "saveDocuments" : false,
    "faxHeaderFrom" : "Max Mustermann",
    "defaultInternationalDialingCode" : "0049",
    "costCenter" : "Kösten",
    "timeToSend" : "2022-01-01T10:00:00+02:00",
    "title" : "Fax Job ABC 123",
    "timeToSendUntil" : "2030-01-01T10:00:00+02:00",
    "clip" : "0525187929310",
    "stationID" : "test12345"
  },
  "errorCode" : 503,
  "id" : "xxxxxxxx-xxxx-xxxx-xxxx-xxxxxxxxxxxx",
  "account" : "ApiAccount123",
  "status" : "scheduling",
  "info" : {
    "templateIsAvailable" : true,
    "previewIsAvailable" : true
  },
  "statistics" : {
    "surcharge" : 1,
    "recipientCountSuccessful" : 8,
    "recipientCountError" : 2,
    "pages" : 1,
    "recipientCount" : 10
  }
}}]
     - parameter body: (body) Describes the required request body to perform an action on the fax job 
     - parameter _id: (path) Identification number (UUID) of the job 

     - returns: RequestBuilder<Job> 
     */
    open class func putJobWithRequestBuilder(body: JobsIdBody, _id: String) -> RequestBuilder<Job> {
        var path = "/jobs/{id}"
        let _idPreEscape = "\(_id)"
        let _idPostEscape = _idPreEscape.addingPercentEncoding(withAllowedCharacters: .urlPathAllowed) ?? ""
        path = path.replacingOccurrences(of: "{id}", with: _idPostEscape, options: .literal, range: nil)
        let URLString = SwaggerClientAPI.basePath + path
        let parameters = JSONEncodingHelper.encodingParameters(forEncodableObject: body)
        let url = URLComponents(string: URLString)


        let requestBuilder: RequestBuilder<Job>.Type = SwaggerClientAPI.requestBuilderFactory.getBuilder()

        return requestBuilder.init(method: "PUT", URLString: (url?.string ?? URLString), parameters: parameters, isBody: true)
    }
}
